function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function _iterableToArrayLimit(r, l) { var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (null != t) { var e, n, i, u, a = [], f = !0, o = !1; try { if (i = (t = t.call(r)).next, 0 === l) { if (Object(t) !== t) return; f = !1; } else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0); } catch (r) { o = !0, n = r; } finally { try { if (!f && null != t.return && (u = t.return(), Object(u) !== u)) return; } finally { if (o) throw n; } } return a; } }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
import { useRef, useLayoutEffect, useState } from 'react';

// threshold: 容差值，表示离底部多远以内都算“在底部”
export var useAutoScroll = function useAutoScroll(dependencies) {
  var threshold = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 100;
  // 指向滚动容器
  var containerRef = useRef(null);
  // 指向一个永远在列表末尾的空div，作为滚动的目标
  var anchorRef = useRef(null);
  var _useState = useState(false),
    _useState2 = _slicedToArray(_useState, 2),
    showScrollDownButton = _useState2[0],
    setShowScrollDownButton = _useState2[1];
  useLayoutEffect(function () {
    var container = containerRef.current;
    if (!container) return;

    // scrollTop: 滚动条距离顶部的距离
    // scrollHeight: 整个可滚动内容的总高度
    // clientHeight: 容器可视区域的高度
    var isAtBottom = container.scrollHeight - container.scrollTop <= container.clientHeight + threshold + 200;

    // 只有当用户已经在底部时，才执行自动滚动
    if (isAtBottom) {
      var _anchorRef$current;
      (_anchorRef$current = anchorRef.current) === null || _anchorRef$current === void 0 || _anchorRef$current.scrollIntoView({
        block: 'end' // 滚动到元素的末尾
      });
      setShowScrollDownButton(false);
    } else {
      setShowScrollDownButton(true);
    }
  }, [dependencies, threshold]); // 依赖项改变时（比如新消息来了），触发此 effect

  return {
    containerRef: containerRef,
    anchorRef: anchorRef,
    showScrollDownButton: showScrollDownButton
  };
};